/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: fputs.c,v 1.1.1.1 1993/04/18 16:22:40 mura Exp $
 * high speed patched by 씎Y(oo), HGG00736@niftyserve.or.jp
 */

/* System headers */
#include <stdio.h>
#include <string.h>
#include <sys/xstdio.h>
#include "istring.h"

/* Functions */
int fputs (const char *string, FILE *fp)
{
    int hope;
    const char *mark;

    /* Ō܂ŏo͂ */
    while (*string) {

	/* ݑobt@ */
	if (_swrite (fp) < 0)
	    return EOF;

	/* obt@O@ʂɏo͂钷߂ */
	if (fp->_flag & _IOLBF) {
		if (mark = _m_strchr (string, '\n')) {
		    hope = mark - string + 1;
		}
		else {
		    hope = _m_strlen (string);
		}
	}
	else
	    hope = _m_strlen (string);

	/* o͉\ȒŐ؂l߂ */
	if (hope > fp->_cnt)
	    hope = fp->_cnt;

	/* obt@Ƀf[^] */
	memcpy (fp->_ptr, string, hope);
	string   += hope;
	fp->_ptr += hope;
	fp->_cnt -= hope;

	/* obt@tbV邩 */
	if (fp->_flag & (_IOLBF | _IONBF))
	    fflush (fp);
    }

    /* ߂ */
    return 0;
}
