/*
 *	list.c: part of oar(Object ARchiver)
 *	Copyright  1995  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	"oar.h"
#include	<sys/dos.h>
#include	"error.h"


void	list_object(header_s* ptr)
{
	byte*	src;
	byte*	dst;
	byte	buff[128];

	if (long_form) {
		dst = (*format)(buff, &ptr->obj_size);
		*dst++ = ' ';
		*dst++ = ' ';
		dst = dosdate(dst, (dostime_s*)&ptr->obj_time);
		*dst++ = ' ';
		*dst++ = ' ';
		src = ptr->obj_name;
		while (*dst++ = *src++);
		*(dst - 1) = '\n';
		*dst = '\0';
		fputs((char*)buff, stdout);
	}
	else {
		puts((char*)ptr->obj_name);
	}
}


int	F_list(int ac, char** av)
{
	int	i;
	byte*	src;
	byte*	dst;
	byte*	base;
	byte*	limit;
	header_s*	ptr;
	header_s*	end;

	if (chk_null) {
		check_null_device();
	}

	if (verbose && ac != 0) warning("R}h -l(--list) ͈Ƃ܂");
	if ((base = (byte*)malloc(BUFSIZ+256)) == (byte*)0) {
		fatal("o̓obt@mۂł܂");
	}
	limit = (dst = base) + BUFSIZ;

	read_archive(0);
	ptr = (header_s*)(archive_buff + ARC_HEADSIZ);
	end = (header_s*)(archive_buff + archive_size);

	/*
	 * -l --list ł har 邽(thanks to Sharl)
	 */
	while (ptr < end) {
		if ((i = dst - limit) >= 0) {
			_dos_write(fileno(stdout), base, BUFSIZ);
			for (dst = base, src = base + BUFSIZ; --i >= 0;) *dst++ = *src++;
		}
		if (long_form) {
			dst = (*format)(dst, &ptr->obj_size);
			*dst++ = ' ';
			*dst++ = ' ';
			dst = dosdate(dst, (dostime_s*)&ptr->obj_time);
			*dst++ = ' ';
			*dst++ = ' ';
		}
		src = ptr->obj_name;
		while (*dst++ = *src++);
		if (concatenate) {
			*(dst - 1) = ' ';
		}
		else {
			*(dst - 1) = '\r';
			*dst++ = '\n';
		}
		ptr = (header_s*)((byte*)(ptr + 1) + ptr->obj_size);
	}
	if (concatenate) {
		*dst++ = '\r';
		*dst++ = '\n';
	}
	if (dst > base) {
		if (_dos_write(fileno(stdout), base, dst - base) != dst - base) {
			fatal("o͂ł܂");
		}
	}
	free(base);
	return 0;
}


