*
*	ltoha.s: part of oar(object archiver)
*	Copyright  1995  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
dst	.ds.l	1
src	.ds.l	1

~cset	.reg	a0
~dst	.reg	a1
~src	.reg	a2
~val	.reg	d0
~ch	.reg	d1
~cnt	.reg	d2

	.text
	.even
cset:
	dc.b	'0123456789abcdef'

	.even
.if	MPU>=68020
	.quad
.endif
*
* char* ltohazs(uchar* dst, ulong* src)
* in:	dst	output buffer
*	src	pointer to convert value
* out:	pointer to end of string
*
_ltohazs6::
	movem.l	dst(sp),~dst/~src
	addq.l	#1,~src
	moveq.l	#2,~cnt
	bra.s	ltohazs
_ltohazs::
	movem.l	dst(sp),~dst/~src
	moveq.l	#3,~cnt
ltohazs:
	lea.l	cset(pc),~cset
	moveq.l	#' ',~ch
zero_chk:
	move.b	(~src)+,~val
	bne.s	conv_first
	move.b	~ch,(~dst)+
	move.b	~ch,(~dst)+
	dbra	~cnt,zero_chk
	move.l	~dst,d0
	rts

conv_first:
	move.b	~ch,(~dst)+
	move.b	~val,~ch
	lsr.b	#4,~ch
	beq.s	@f
	move.b	(~cset,~ch.w),-1(~dst)
@@:
	moveq.l	#$f,~ch
	and.b	~val,~ch
	move.b	(~cset,~ch.w),(~dst)+
	dbra	~cnt,conv_loop
	move.l	~dst,d0
	rts

_ltoha::
	movem.l	dst(sp),~dst/~src
	moveq.l	#0,~ch
	moveq.l	#3,~cnt
	lea.l	cset(pc),~cset
*	bra.s	conv_loop
conv_loop:
	move.b	(~src)+,~val
	move.b	~val,~ch
	lsr.b	#4,~ch
	move.b	(~cset,~ch.w),(~dst)+
	moveq.l	#$f,~ch
	and.b	~val,~ch
	move.b	(~cset,~ch.w),(~dst)+
	dbra	~cnt,conv_loop
	move.l	~dst,d0
	rts
	.end
