/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: puts.c,v 1.1.1.1 1993/04/18 16:23:03 mura Exp $
 * high speed patched by 씎Y(oo), HGG00736@niftyserve.or.jp
 */

/* System headers */
#include <stdio.h>
#include <string.h>
#include <sys/xstdio.h>
#include "istring.h"

/* Functions */
int puts (const char *string)
{
    int hope;
    const char *mark;

    /* Ō܂ŏo͂ */
    while (*string) {

	/* ݑobt@ */
	if (_swrite (stdout) < 0)
	    return EOF;

	/* obt@O@ʂɏo͂钷߂ */
	if ((stdout->_flag & _IOLBF) && (mark = _m_strchr (string, '\n')))
	    hope = mark - string + 1;
	else
	    hope = _m_strlen (string);

	/* o͉\ȒŐ؂l߂ */
	if (hope > stdout->_cnt)
	    hope = stdout->_cnt;

	/* obt@Ƀf[^] */
	memcpy (stdout->_ptr, string, hope);
	string   += hope;
	stdout->_ptr += hope;
	stdout->_cnt -= hope;

	/* obt@tbV邩 */
	if (stdout->_flag & (_IOLBF | _IONBF))
	    fflush (stdout);
    }
    fputc('\n', stdout);

    /* ߂ */
    return 0;
}

