/*
 *	replace.c: part of oar(Object ARchiver)
 *	Copyright  1995  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	"oar.h"
#include	<string.h>
#include	"error.h"


int	F_replace(int ac, char** av)
{
	int	idx;
	lword	time0, time1;
	size_t	size0, size1;
	hash_s*	hashptr;
	header_s*	ptr;

	if (ac == 0) fatal("R}h -r(--replace) ɂ͈Kvł");

	read_archive(2);

	for (idx = 0; idx < ac; idx++) {
		if (read_object(av[idx]) >= 0) {
			if (hashptr = hash_lookup(archive_ptr)) {
				ptr = (header_s*)hashptr->obj_name;
				if (force == 0) {
					time0 = *(lword*)&((header_s*)archive_ptr)->obj_time;
					time1 = *(lword*)&ptr->obj_time;
					asm("swap\t%0"::"d"(time0));
					asm("swap\t%0"::"d"(time1));

					/* ǂݍ񂾃t@C̕ÂꍇAȂ */
					if (time0 <= time1) continue;
				}

				old_archive_ptr = archive_ptr;
				size0 = ((header_s*)archive_ptr)->obj_size;
				size1 = ptr->obj_size;

				/* TCYقȂƌԂł */
				if (size0 != size1) ++delete_count;

				if (size0 <= size1) {
					/*
					 *	VKIuWFNg̕
					 *	IuWFNg͓Ȃ̂ŃRs[Ȃ
					 */
					memcpy((byte*)ptr + OBJNAME_MAX, (byte*)archive_ptr + OBJNAME_MAX,
							sizeof(header_s) - OBJNAME_MAX + size0);
				}
				else {
					/*
					 *	VKIuWFNg̕傫̂ŁAŌɒǉ
					 */
					hashptr->obj_name = archive_ptr;
					(hashptr->name_ptr)->obj_name = archive_ptr;

					size0 += HEADERSIZ;
					archive_ptr  += size0;
					archive_size += size0;
				}
			}
			else {
				append_object();
			}
			if (verbose) list_object((header_s*)old_archive_ptr);
		}
		else {
			error("IuWFNgt@C %s I[vł܂", av[idx]);
		}
	}
	write_archive();
	return 0;
}


