/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _errlist.c,v 1.5 1994/07/27 13:47:13 mura Exp $
 * japanese message version by oo
 */

/* System headers */
#include <errno.h>

/* External variables */
__common char *sys_errlist[] = {
#if	0
/*	"Unknown error",*/				/* ERROR */
	"m̃G[ł",
#endif

/*	"No error",*/						/*  0 */
	"G[͂܂",

/*	"Domain error",*/					/*  1:EDOM */
	"`Öł",

/*	"Result too large",*/				/*  2:ERANGE */
	"Zʂ傫܂",

/*	"Arg list too long",*/				/*  3:E2BIG */
	"܂",

/*	"Permission denied",*/				/*  4:EACCES */
	"ANZXĂ܂",

/*	"Resource temporarily unavailable",	/*  5:EAGAIN */
	"\[XꎞIɖł",

/*	"Bad file descriptor",*/			/*  6:EBADF */
	"sȃt@CfBXNv^ł",

/*	"Resource busy",*/					/*  7:EBUSY */
	"\[XrW[ł",

/*	"No child process",*/				/*  8:ECHILD */
	"`ChvZX݂͑܂",

/*	"Resource deadlock would occur",*/	/*  9:EDEADLK */
	"fbhbN܂",

/*	"File exists",*/					/* 10:EEXIST */
	"t@Cɑ݂Ă܂",

/*	"Invalid address",*/				/* 11:EFAULT */
	"sȃAhXgp܂",

/*	"File too large",*/					/* 12:EFBIG */
	"t@C傫܂",

/*	"Interrupted function call",*/		/* 13:EINTR */
	"荞݂ɂ菈𒆒f܂",

/*	"Invalid argument",*/				/* 14:EINVAL */
	"sȈł",

/*	"Input/output error",*/				/* 15:EIO */
	"o̓G[܂",

/*	"Is a directory",*/					/* 16:EISDIR */
	"fBNgł",

/*	"Too many symbolic links",*/		/* 17:ELOOP */
	"V{bNÑlXg[܂",

/*	"Too many open files",*/			/* 18:EMFILE */
	"t@CI[vł",

/*	"Too many links",*/					/* 19:EMLINK */
	"N܂",

/*	"Filename too long",*/				/* 20:ENAMETOOLONG */
	"t@C܂",

/*	"Too many files open in system",*/	/* 21:ENFILE */
	"VXet@Ce[uӂ܂",

/*	"No such device",*/					/* 22:ENODEV */
	"̂悤ȃfoCX͂܂",

/*	"No such file or directory",*/		/* 23:ENOENT */
	"̂悤ȃt@CfBNg͂܂",

/*	"Exec format error",*/				/* 24:ENOEXEC */
	"st@C̃tH[}bgsł",

/*	"No locks available",*/				/* 25:ENOLCK */
	"Lȃt@CbN͂܂",

/*	"Not enough memory space",*/		/* 26:ENOMEM */
	"\ȋ󂫃܂",

/*	"No space left on a device",*/		/* 27:ENOSPC */
	"foCXɋ󂫗̈悪܂",

/*	"Block device required",*/			/* 28:ENOTBLK */
	"ubNfoCXłȂ΂܂",

/*	"Function not implemented",*/		/* 29:ENOSYS */
	"̋@\͎Ă܂",

/*	"Not a directory",*/				/* 30:ENOTDIR */
	"fBNgł͂܂",

/*	"Directory not empty",*/			/* 31:ENOTEMPTY */
	"fBNgł͂܂",

/*	"Inappropriate I/O control",*/		/* 32:ENOTTY */
	"sK I/O ł",

/*	"No such device or address",*/		/* 33:ENXIO */
	"̂悤ȃfoCXAhX͂܂",

/*	"Operation not permitted",*/		/* 34:EPERM */
	"ĂȂł",

/*	"Broken pipe",*/					/* 35:EPIPE */
	"pCvj܂",

/*	"Read only file system",*/			/* 36:EROFS */
	"ǂݍݐp̃t@CVXeł",

/*	"Invalid seek",*/					/* 37:ESPIPE */
	"sȃV[Nł",

/*	"Text file busy",*/					/* 38:ETXTBSY */
	"ÕXbhɑ݂܂",

/*	"No such process",*/				/* 39:ESRCH */
	"̂悤ȃvZX݂͑܂",

/*	"Improper link",*/					/* 40:EXDEV */
	"Nł",

/*	"Read only device file system",*/	/* 41:EDEVFS */
	"ǂݍݐp̃foCXł",
};

/* External variables */
int sys_nerr = sizeof (sys_errlist) / sizeof (char *);

/* External variables */
int errno;

