/* ansidecl.h: GNU ansidecl.h compatible header

   ̃t@C GNU ansidecl.h ݊ PDS wb_
   쌠͕Ă̂ŎRɎgp\ł
*/

/*
   ANSI C ł́A}N __STDC__ `ĂƉ肵Ă

   Macro        ANSI C definition   Traditional C definition
   ------       ---- - ----------   ----------- - ----------
   PTR          `void *'            `char *'
   LONG_DOUBLE  `long double'       `double'
   CONST        `const'             `'
   VOLATILE     `volatile'          `'
   SIGNED       `signed'            `'
   PTRCONST     `void *const'       `char *'

   AND          `,'                 `;'
   NOARGS       `void'              `'
   DOTS         `, ...'             `'


gp@

* DEFUN(name, (arglist), args)

	name	֐̖O
	arglist	R}ŋ؂
	args	AND ŋ؂^錾܂񂾈

	arglist ́AR}ŋ؂ĕׂBarglist ͊ʂŊ
	KvB

	args ́A^ƂƂɈ}N `AND' ŋ؂ĕׂB
	ψɂ̓}N `DOTS' g

	yz	int DEFUN(main, (argc, argv), int argc AND char** argv) { ... }
			int DEFUN(printf, (format DOTS), CONST char *format DOTS) { ... }

* DEFUN_VOID(name)

	name	Ȃ֐

	yz	VOLATILE void DEFUN_VOID(abort) { ... }


* EXFUN(name, (prototype))

	name		extern 錾֐
	prototype	R}ŋ؂vg^Cv

	ANSI C ł name prototype A ANSI C ł name() ƓWJB
	Ȃ֐ł̓}N NOARGS gB

	yz	extern int EXFUN(fprintf, (FILE* stream, CONST char *format DOTS));
			extern VOLATILE void EXFUN(abort, (NOARGS));

*/

#ifndef	_ANSIDECL_H

#define	_ANSIDECL_H	1

/* LINTLIBRARY */


#ifdef	__STDC__

#define	PTR		void *
#define	PTRCONST	void *CONST
#define	LONG_DOUBLE	long double

#define	AND		,
#define	NOARGS		void
#define	CONST		const
#define	VOLATILE	volatile
#define	SIGNED		signed
#define	DOTS		, ...

#define	EXFUN(name, proto)		name proto
#define	DEFUN(name, arglist, args)	name(args)
#define	DEFUN_VOID(name)		name(NOARGS)

#else	/* Not ANSI C.  */

#define	PTR		char *
#define	PTRCONST	PTR
#define	LONG_DOUBLE	double

#define	AND		;
#define	NOARGS
#define	CONST
#define	VOLATILE
#define	SIGNED
#define	DOTS

#define	EXFUN(name, proto)		name()
#define	DEFUN(name, arglist, args)	name arglist args;
#define	DEFUN_VOID(name)		name()

#endif	/* ANSI C.  */


#endif	/* ansidecl.h	*/
