/*
 *	append.c: part of oar(Object ARchiver)
 *	Copyright  1995  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	"oar.h"
#include	"error.h"


void	append_object(void)
{
	hash_s*	ptr;
	size_t	size;

	if ((ptr = hash_install(archive_ptr)) == (hash_s*)0) {
		fatal("nbVe[uς %s ǉo^ł܂", archive_ptr);
	}
	if (name_install(archive_ptr, ptr) == -1) {
		fatal("IuWFNge[uς %s ǉo^ł܂", archive_ptr);
	}
	size = HEADERSIZ + ((header_s*)archive_ptr)->obj_size;
	old_archive_ptr = archive_ptr;
	archive_ptr  += size;
	archive_size += size;
}


int	F_append(int ac, char** av)
{
	int	idx;
	size_t	size;
	lword	time0, time1;
	hash_s*	hashptr;
	header_s*	ptr;

	if (ac == 0) fatal("R}h -a(--append) ɂ͈Kvł");

	read_archive(2);

	for (idx = 0; idx < ac; idx++) {
		if (read_object(av[idx]) >= 0) {
			if (hashptr = hash_lookup(archive_ptr)) {
				ptr = (header_s*)hashptr->obj_name;
				if (force == 0) {
					time0 = *(lword*)&((header_s*)archive_ptr)->obj_time;
					time1 = *(lword*)&ptr->obj_time;
					asm("swap\t%0"::"d"(time0));
					asm("swap\t%0"::"d"(time1));

					/* ǂݍ񂾃t@C̕ÂꍇAȂ */
					if (time0 <= time1) continue;
				}

				/* ΉIuWFNge[ũGg폜 */
				(hashptr->name_ptr)->obj_name = (name_t)0;
				++delete_count;

				/* nbVe[uGgւ */
				hashptr->obj_name = old_archive_ptr = archive_ptr;

				if (name_install(archive_ptr, hashptr) == -1) {
					fatal("IuWFNge[uς %s ǉo^ł܂", archive_ptr);
				}
				size = HEADERSIZ + ((header_s*)archive_ptr)->obj_size;
				archive_ptr  += size;
				archive_size += size;
			}
			else {
				append_object();
			}
			if (verbose) list_object((header_s*)old_archive_ptr);
		}
		else {
			error("IuWFNgt@C %s I[vł܂", av[idx]);
		}
	}
	write_archive();
	return 0;
}


