/*
 *	extract.c: part of oar(Object ARchiver)
 *	Copyright  1995  씎Y(oo), HGG00736@niftyserve.or.jp
 */
#include	"oar.h"
#include	<sys/dos.h>
#include	"error.h"


static void	extract_object(header_s* ptr)
{
	int	fd;
	lword	time0, time1;

	if (force == 0) {
		/* Abvf[g[h */
		if ((fd = _dos_open(ptr->obj_name, 0)) >= 0) {
			time0 = _dos_filedate(fd, 0);
			_dos_close(fd);
			time1 = *(lword*)&ptr->obj_time;
			asm("swap\t%0"::"d"(time0));

			/* Ot@C̕Vꍇ͉Ȃ */
			if (time0 >= time1) return;
		}
	}

	if ((fd = _dos_create(ptr->obj_name, 0x20)) < 0) {
		fatal("IuWFNgt@C %s 쐬ł܂", ptr->obj_name);
	}
	if (_dos_write(fd, (const char*)(ptr + 1), ptr->obj_size) != ptr->obj_size) {
		fatal("IuWFNgt@C %s ߂܂", ptr->obj_name);
	}
	time0 =  *(lword*)&ptr->obj_time;
	asm("swap\t%0"::"d"(time0));
	_dos_filedate(fd, time0);
	_dos_close(fd);
	if (verbose) list_object(ptr);
}


int	F_extract(int ac, char** av)
{
	int	idx;
	hash_s*	hashptr;
	header_s*	ptr;

	if (ac == 0) oar_term(F_extall(ac, av));

	read_archive(1);

	for (idx = 0; idx < ac; idx++) {
		if (hashptr = hash_lookup(av[idx])) {
			ptr = (header_s*)hashptr->obj_name;
			extract_object(ptr);
		}
		else {
			error("IuWFNgt@C %s o܂", av[idx]);
		}
	}
	return 0;
}


int	F_extall(int ac, char** av)
{
	header_s*	ptr;
	header_s*	end;

	if (verbose && ac != 0) warning("R}h -e(--extract-all) ͈Ƃ܂");

	read_archive(0);
	ptr = (header_s*)(archive_buff + ARC_HEADSIZ);
	end = (header_s*)(archive_buff + archive_size);

	while (ptr < end) {
		extract_object(ptr);
		ptr = (header_s*)((byte*)(ptr + 1) + ptr->obj_size);
	}
	return 0;
}


