*
*	ltoda.s: part of oar(Object ARchiver)
*	Copyright  1994,95  씎Y(oo), HGG00736@niftyserve.or.jp
*
.ifndef	MPU
MPU	.equ	68000
.endif

	.offset	4
dst	.ds.l	1
src	.ds.l	1

	.text
	.even
.if	MPU>=68020
	.quad
.endif
ltoda_tab:
	.dc.l 1000000000
	.dc.l 100000000
	.dc.l 10000000
	.dc.l 1000000
	.dc.l 100000
	.dc.l 10000
	.dc.l 1000
	.dc.l 100
	.dc.l 10
	.dc.l 0

~val	.reg	d0
~tval	.reg	d1
~ch	.reg	d2
~dst	.reg	a0
~src	.reg	a1
~tab	.reg	a2

_ltodazs::
	movem.l	dst(sp),~dst/~src
	moveq.l	#' ',~ch
	bra.s	ltoda
_ltoda::
	movem.l	dst(sp),~dst/~src
	moveq.l	#'0',~ch
ltoda:
	move.l	(~src),~val
	lea.l	ltoda_tab(pc),~tab
	moveq.l	#9,~tval
	cmp.l	~val,~tval
	bcs.s	ltoda_cmp
	moveq.l	#8,~tval
ltoda_0_loop:
	move.b	~ch,(~dst)+
	dbra	~tval,ltoda_0_loop
	bra.s	ltoda_conv_end

ltoda_cmp_loop:
	move.b	~ch,(~dst)+
ltoda_cmp:
	cmp.l	(~tab)+,~val
	blo.s	ltoda_cmp_loop
	move.l	-4(~tab),~tval
	moveq.l	#'0',~ch
	bra.s	ltoda_sub_value

ltoda_inc_ch:
	addq.b	#1,~ch
ltoda_sub_value:
	sub.l	~tval,~val
	bcc.s	ltoda_inc_ch
	add.l	~tval,~val
	move.b	~ch,(~dst)+
	move.l	(~tab)+,~tval
	beq.s	ltoda_conv_end
ltoda_set_ch:
	moveq.l	#'0',~ch
	bra.s	ltoda_sub_value

ltoda_conv_end:
	add.b	#'0',~val
	move.b	~val,(~dst)+
	move.l	~dst,d0
	rts
	.end
