#ifndef	_STRMACRO_H_
/*
 *	strmacro.h: multi byte char/string header
 *              by 씎Y(oo)  HGG00736@niftyserve.or.jp
 *
 *	쌠͕Ă̂ŎRɎgp\ł
 *
 *	BSDnUNIX ł HAVE_STRINGS_H `ĉ
 *	HAVE_MBCTYPE_H/HAVE_MBSTRING_H, HAVE_JCTYPE_H/HAVE_JSTRING_H
 *  ̂ꂩ`ĉ
 */
#define	_STRMACRO_H_	1

#ifdef	HAVE_CONFIG_H
#include	"config.h"
#else	/*!HAVE_CONFIG_H*/

#ifndef	HAVE_MBCTYPE_H
/**/
#define	HAVE_MBCTYPE_H	1
/**/
#endif
#ifndef	HAVE_JCTYPE_H
/*
#define	HAVE_JCTYPE_H	1
*/
#else
#ifdef	HAVE_MBCTYPE_H
#undef	HAVE_MBCTYPE_H
#endif
#endif

#ifndef	HAVE_MBSTRING_H
/**/
#define	HAVE_MBSTRING_H	1
/**/
#endif
#ifndef	HAVE_JSTRING_H
/*
#define	HAVE_JSTRING_H	1
*/
#else
#ifdef	HAVE_MBSTRING_H
#undef	HAVE_MBSTRING_H
#endif
#endif

#endif	/*HAVE_CONFIG_H*/


#if	defined(HAVE_MBCTYPE_H)
#include	<mbctype.h>
#define	/*int*/ISMBBLEAD(/*int*/c)	ismbblead(c)
#define	/*int*/ISMBBTRAIL(/*int*/c)	ismbbtrail(c)
#elif	defined(HAVE_JCTYPE_H)
#include	<jctype.h>
#define	/*int*/ISMBBLEAD(/*int*/c)	iskanji(c)
#define	/*int*/ISMBBTRAIL(/*int*/c)	iskanji2(c)
#else	/*NO mbctype.h && NO jctype.h*/
#if	defined(EUC)
#define	/*int*/ISMBBLEAD(/*int*/c)	(0xa0<(c)&&(c)<0xff)
#define	/*int*/ISMBBTRAIL(/*int*/c)	(0xa0<(c)&&(c)<0xff)
#else
#define	/*int*/ISMBBLEAD(/*int*/c)	(0x80<(c)&&(c)<0xa0||0xe0<=(c)&&(c)<0xfd)
#define	/*int*/ISMBBTRAIL(/*int*/c)	(0x40<=(c)&&(c)<0xfd&&(c)!=0x7f)
#endif
#endif


#if	defined(HAVE_MBSTRING_H)
#include	<mbstring.h>
#define	/*char**/STRCHR(/*char**/s,/*int*/c)	\
		(char*)mbschr((unsigned char*)(s),(c))
#define	/*char**/STRRCHR(/*char**/s,/*int*/c)	\
		(char*)mbsrchr((unsigned char*)(s),(c))
#elif	defined(HAVE_JSTRING_H)
#include	<jstring.h>
#define	/*char**/STRCHR(/*char**/s,/*int*/c)	\
		(char*)jstrchr((unsigned char*)(s),(c))
#define	/*char**/STRRCHR(/*char**/s,/*int*/c)	\
		(char*)jstrrchr((unsigned char*)(s),(c))
#else	/*NO mbstring.h && NO jstring.h*/
#define	STRCHR	strchr
#define	STRRCHR	strrchr
#endif

#ifdef	HAVE_STRINGS_H
#include	<strings.h>
#define	strchr	index
#define	strrchr	rindex
#else
#include	<string.h>
#endif

#endif	/*_STRMACRO_H_*/
